using System;
using System.Collections;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.IO;
using Microsoft.VisualBasic;
using Microsoft.WindowsCE.Forms;
using System.Runtime.InteropServices;

namespace notification
{

    public class NotifyIcon : IDisposable
    {

        static int pxx;
        static int pyy;
        static int timeron=0;
        static Control frm;

        private object[] HoldEventObject;
        private object[] ClickEventObject;
        public event EventHandler Hold;
        public event EventHandler Click;
        static Timer tmr = new Timer();
        
        public int HoldNITime
        {
            get { return holdtime; }
            set { holdtime = value; }
        }

        private int holdtime = 500;

        private WS ws;
        private int uID = 5000;

        public NotifyIcon(Control Frm1)
        {
            frm = Frm1;
            tmr.Tick += new EventHandler(timer_Tick);
			tmr.Interval = holdtime;
            pxx = 130;
            pyy = 200;


            HoldEventObject = new object[] { this, "Hold" };
            ClickEventObject = new object[] { this, "Click"};
            
            ws = new WS(this);
            ws.uID = uID;
          
        }

		void  timer_Tick(object sender, EventArgs e)
        {
			timeron=1;
        }
	



        public void AddNIContextMenu(Control ControlName, System.Windows.Forms.ContextMenu ContextMenu)
        {
            ControlName.ContextMenu = ContextMenu;
        }
        public void RemoveNIContextMenu(Control ControlName)
        {
            ControlName.ContextMenu = null;
        }

        public void SetNIMenuXY(int px, int py) 
        {
            pxx = px;      
            pyy = py;
                
        }

        public void ShowNIMenu()
        {
            frm.ContextMenu.Show(frm, new Point(pxx, pyy));
        }


        public void AddNIicon(Icon ike)
        {
            IntPtr hIcon;
            hIcon = ike.Handle;


            TrayMessage(ws.Hwnd, NIM_ADD, (uint)uID, hIcon);
        }

        public void RemoveNIicon()
        {

            TrayMessage(ws.Hwnd, NIM_DELETE, (uint)uID, IntPtr.Zero);
        }

        public void ModifyNIicon(Icon ike2)
        {
            IntPtr hIcon;
            hIcon = ike2.Handle;
            TrayMessage(ws.Hwnd, NIM_MODIFY, (uint)uID, hIcon);

        }

        private void TrayMessage(IntPtr hwnd, int dwMessage, uint uID, IntPtr hIcon)
        {
            NOTIFYICONDATA notdata = new NOTIFYICONDATA();

            notdata.cbSize = 152;
            notdata.hIcon = hIcon;
            notdata.hWnd = hwnd;
            notdata.uCallbackMessage = WM_NOTIFY_TRAY;
            notdata.uFlags = NIF_MESSAGE | NIF_ICON;
            notdata.uID = uID;

            int ret = Shell_NotifyIcon(dwMessage, ref notdata);
        }

        public void Dispose()
        {
        	
            try
            {
                Hold = null;
                Click = null;
                tmr.Tick -= new EventHandler(timer_Tick);
                RemoveNIicon();
            }
            finally { }
        }



        internal const int WM_LBUTTONDOWN = 0x0201;
        internal const int WM_LBUTTONUP = 0x0202;
        internal const int WM_LBUTTONDBLCLK = 0x0203;
        internal const int WM_NOTIFY_TRAY = 0x0400 + 2001;

        internal const int NIM_ADD = 0x00000000;
        internal const int NIM_MODIFY = 0x00000001;
        internal const int NIM_DELETE = 0x00000002;

        const int NIF_MESSAGE = 0x00000001;
        const int NIF_ICON = 0x00000002;


        internal struct NOTIFYICONDATA
        {
            internal int cbSize;
            internal IntPtr hWnd;
            internal uint uID;
            internal uint uFlags;
            internal uint uCallbackMessage;
            internal IntPtr hIcon;
        }

        [DllImport("coredll.dll")]
        internal static extern int Shell_NotifyIcon(
            int dwMessage, ref NOTIFYICONDATA pnid);

        [DllImport("coredll.dll")]
        internal static extern int SetForegroundWindow(IntPtr hWnd);

        [DllImport("coredll.dll")]
        internal static extern int ShowWindow(
            IntPtr hWnd,
            int nCmdShow);

        [DllImport("coredll.dll")]
        internal static extern IntPtr GetFocus();

        [DllImport("coredll.dll")]
        internal static extern IntPtr LoadIcon(IntPtr hInst, string IconName);

        [DllImport("coredll.dll")]
        internal static extern IntPtr GetModuleHandle(String lpModuleName);


        internal class WS : Microsoft.WindowsCE.Forms.MessageWindow
        {
            private int m_uID = 0;
            private NotifyIcon notifyIcon;

            protected internal WS(NotifyIcon notIcon)
            {
                notifyIcon = notIcon;
            }

            public int uID
            {
                set
                {
                    m_uID = value;

                }
            }

            protected override void WndProc(ref Microsoft.WindowsCE.Forms.Message msg)
            {

                if (msg.Msg == WM_NOTIFY_TRAY)
                {
                    if ((int)msg.WParam == m_uID)
                    {
                            if ((int)msg.LParam == WM_LBUTTONDOWN)
                            {
								tmr.Enabled = true;
                            }
                            if ((int)msg.LParam == WM_LBUTTONUP)
                            {
                            	tmr.Enabled=false;
                            	if (timeron == 0)
             					{
                  					notifyIcon.Click(notifyIcon.ClickEventObject, null); 
             					}
                            	else
                            	{
                            		notifyIcon.Hold(notifyIcon.HoldEventObject, null);
                            		timeron=0;
                            	}
             					
                            }                        
                    }
                    
                }
            }
        }
    }

    public class ContextMenu : IDisposable
    {
        private System.Windows.Forms.ContextMenu cm;
        public event EventHandler Click;
        private object[] eventObject;
        private string selectedText;
        private int selectedIndex;

        public ContextMenu()
        {
            cm = new System.Windows.Forms.ContextMenu();
            eventObject = new object[] { this, "Click" };

        }
        public void CMAddItem(string Text)
        {
            MenuItem mnu = new MenuItem();
            mnu.Text = Text;
            mnu.Click += new EventHandler(mnu_Click);
            cm.MenuItems.Add(mnu);
        }


        public void CMRemoveItem(int Index)
        {
            cm.MenuItems.RemoveAt(Index);
        }

        public string CMSelectedText
        {
            get { return selectedText; }
        }
        public int CMSelectedIndex
        {
            get { return selectedIndex; }
        }
        public int CMCount
        {
            get { return cm.MenuItems.Count; }
        }

        private void mnu_Click(object sender, EventArgs e)
        {
            MenuItem mnu = (MenuItem)sender;
            selectedText = mnu.Text;
            selectedIndex = cm.MenuItems.IndexOf(mnu);
            if (Click != null)
                Click(eventObject, null);
        }
        public System.Windows.Forms.ContextMenu Value
        {
            get { return cm; }
            set { cm = value; }
        }

        public void Dispose()
        {
            Click = null;
            cm = null;
        }

    }

    public class Balloon : IDisposable
    {
        public string response = "";
		private string temp;
        private bool boo;
        private double dub;
        private int inti;
        private Icon ico;
        
        private Microsoft.WindowsCE.Forms.Notification noti;
			
        private object[] BalloonChangedEventObject;
        private object[] ResponseSubmittedEventObject;


        public event EventHandler BalloonChanged;
        public event EventHandler ResponseSubmitted;



        // constructor
        public Balloon()
        {
            noti = new Microsoft.WindowsCE.Forms.Notification();

            BalloonChangedEventObject = new object[] { this, "BalloonChanged" };
            ResponseSubmittedEventObject = new object[] { this, "ResponseSubmitted" };

            noti.BalloonChanged += BalloonChangedEvent;
            noti.ResponseSubmitted += ResponseSubmittedEvent;

        }



        // private methods
        private void BalloonChangedEvent(object sender, EventArgs e)
        {
            if (BalloonChanged != null)
            {
                BalloonChanged(BalloonChangedEventObject, null);
            }
        }

        private void ResponseSubmittedEvent(object sender, ResponseSubmittedEventArgs e)
        {
            response = e.Response;
            if (ResponseSubmitted != null)
            {
                ResponseSubmitted(ResponseSubmittedEventObject, null);
            }
        }





        //methods
        public void Dispose()
        {
            if (noti != null)
            {
                noti.BalloonChanged -= BalloonChangedEvent;
                noti.ResponseSubmitted -= ResponseSubmittedEvent;
                noti.Dispose();
                noti = null;
            }
        }

        // properties

        public String BCaption
        { get { return noti.Caption; } set { noti.Caption = value; } }

        public bool BCritical
        { get { return noti.Critical; } set { noti.Critical = value; } }

        public double BDLLversion
        { get { return 1; } }

        public Icon BIcon
        { get { return noti.Icon; } set { noti.Icon = value; } }

        public int BInitialDuration
        { get { return noti.InitialDuration; } set { noti.InitialDuration = value; } }

        public String BResponse
        { get { return response; } set { response = value; } }

        public String BText
        { get { return noti.Text; } set { noti.Text = value; } }

        public bool BVisible
        { get { return noti.Visible; } set { noti.Visible = value; } }
    }

    public class IconList : IDisposable
    {
        private ArrayList Ilist;

        // constructor
        public IconList()
        {
            Ilist = new ArrayList();
        }

        // public properties
        public ArrayList ControlRef
        { get { return Ilist; } }

        public int ILcount
        { get { return Ilist.Count; } }

        public double ILDLLversion
        { get { return 1; } }


        // public methods

        public void ILaddstream(Stream path)
        {
            Ilist.Add(new Icon(path));
        }

        public void ILaddicon(Icon icon)
        {
            Ilist.Add(icon);
        }

        public void ILclear()
        {
            Ilist.Clear();
        }

        public Icon ILitem(int index)
        {
            return (Icon)Ilist[index];
        }

        public void Dispose()
        {
            Ilist = null;
        }
    }


}

